<?php

/*
  Plugin Name: wp Sonic Defender
Plugin URI: http://www.wpsonicdefender.com
  Description: wp Sonic Defender protects against brute force attacks by creating a secure login url and redirecting all access attempts to wp-login.php to any page specified.  It is the first and last defense against brute force attacks!
  Version: 1.0
Author: Process Driven Results Inc.
Author URI: http://www.pluginresults.com
 */



register_uninstall_hook(__FILE__, array('mskr_kryptos', 'mskr_uninstall'));


/// menu & options page
// Hook for adding admin menus

register_activation_hook( __FILE__, 'mskr_activate' );
add_action('admin_menu', 'mskr_add_pages');	
add_action('login_init', 'mskr_redirect');
add_action( 'wp_enqueue_scripts', 'mskr_admin_script' );
add_action( 'wp_enqueue_scripts', 'mskr_frontend_script' ); 
add_action( 'load-profile.php', 'redirect_user_profile' );
add_action( 'load-user-edit.php', 'redirect_user_profile' );
add_shortcode( 'MSKR_LOGIN', 'login_shortcode' );
add_shortcode( 'MSKR_PROFILE', 'profile_shortcode' );
if($_REQUEST['mskruni'] == 'mlmmskr')
	add_action('admin_init', 'mskr_process_form');	

function mskr_activate() {
global $wpdb;
$user_ID = get_current_user_id();
$slug = 'profile';
$postTitle = 'Edit Profile';
$form = '[MSKR_PROFILE]';
	$my_post = array(
	  'post_title'    	=> 	$postTitle,
	  'post_content'  	=> 	$form,
	  'post_status'   	=> 	'publish',
	  'post_author'   	=> 	$user_ID,
	  'post_type' 		=> 'page',
	  'post_name' 		=> 	$slug,
	);
		  $query = $wpdb->prepare(
        "SELECT count(ID) FROM $wpdb->posts
        WHERE post_title = '$postTitle'
		AND post_status = 'publish'
        AND post_type = 'page'"
        
    );
    $count = $wpdb->get_var( $query );	
		if (  $count == 0 )
		{
			$pid = wp_insert_post( $my_post );
			update_option('maskr_profile_redirect', get_permalink($pid));
		}
}

function redirect_user_profile ()
{
	$mskr_settings = get_option( 'mskr_kryptos');
	if(current_user_can('manage_options'))
	return true;
	if($mskr_settings['mskr_profile_fend'] == 'on')
	{
		$url = get_option('maskr_profile_redirect');
		wp_redirect($url, '302');
	}
	else
	return true;
	
}
	function mskr_add_pages() {
		// Add a new submenu under Settings:
	 $page =   add_options_page(__('wp Sonic Defender','wpsonicdefender-menu'), __('wp Sonic Defender','wpsonicdefender-menu'), 'manage_options', 'wpsonicdefender', 'mskr_settings_page');
	 add_action( 'admin_print_scripts-' . $page, 'mskr_admin_script' );
	 add_action( 'admin_print_styles-' . $page, 'mskr_admin_styles' );
	}
	 function mskr_admin_styles() {
			wp_register_style( 'mskr-style', plugins_url('view/css/admin-general.css', __FILE__) );
			wp_enqueue_style( 'mskr-style' );
			wp_enqueue_script( 'mskr-adscript', plugins_url('view/css/mskr_admin.js', __FILE__), array('jquery'),false );
			
	   }
   function mskr_admin_script()
          {
            echo '<script> 
			var mskr_plugin_url = "' . plugins_url() . '/wp-sonic-defender";
			var mskr_admin_url = "' . admin_url() .'";
			 </script>';
          }

	function mskr_settings_page() {
		global $mskr_settings;
	   include('view/options.php');
	
	}

	function mskr_process_form() {
	//	print_r($_POST); //die();
		if ( !empty($_POST) &&  check_admin_referer('mskrkryptos'))
		{
				$update = update_option( 'mskr_kryptos', $_POST ); 
				if(isset($_POST['mskr_email_send'])) 
					$mailsent = mskr_email_url2admin();
				
				if($mailsent)
					$message = __('Successfully Updated and Email Sent to Admin!', 'mskryptos');
				else
					$message = __('Successfully Updated!', 'mskryptos');
				
				wp_redirect(admin_url().'options-general.php?page=wpsonicdefender&message='.urlencode($message));
		}
			
	}

	function mskr_email_url2admin(){
    global $current_user;
    get_currentuserinfo();
	$mskr_settings = get_option( 'mskr_kryptos');
		if (current_user_can( 'manage_options' )){ 
			$to = get_option('admin_email');
			$subject = get_option('blogname').' - Your Secure Login URL';
			$message = "Hi ".$current_user->display_name.
			", \r\n\r\n Your secure Login URL to 
			".get_option('blogname')." is : \r\n\r\n 
			". wp_login_url()."?".$mskr_settings['mskr_question']."=".$mskr_settings['mskr_answer']." \r\n\r\n
			";
			$message .= isset($mskr_settings['mskr_customurl'])? 
			'Custom Login URL: '.$mskr_settings['mskr_customurl']:'';
			$message .="\r\n\r\n Please keep this safe. \r\n\r\n Cheers."; 
			$mail =  wp_mail( $to, $subject, $message);  
	return $mail; 
		}
	}

	function mskr_redirect() {
		 $mskr_settings = get_option( 'mskr_kryptos');
		 if(!empty($mskr_settings) && ($_REQUEST[$mskr_settings['mskr_question']] == $mskr_settings['mskr_answer'] || $_REQUEST['action'] == 'lostpassword' || $_REQUEST['action'] == 'rp') )
		 return true;
		 else
		wp_redirect($mskr_settings['mskrredirect_url'], '302');
	}
	 

	function mskr_frontend_script()
	{
		wp_enqueue_script( 'mskrforntened',plugins_url('view/css/mskr_frontend.js', __FILE__), array('jquery'), '', true );
		wp_register_style( 'mskrforntenedstyle', plugins_url('view/css/frontend-style.css', __FILE__) );
        wp_enqueue_style( 'mskrforntenedstyle' );
		
	}
	
	
	
	
	function login_shortcode( $atts ) {
		include('login_shortcode.php');
	}
	
	function profile_shortcode()
	{
		include('profile_shortcode.php');
	}

	function mskr_uninstall()
	{
		delete_option( 'mskr_kryptos'); 
	}
?>